<?php
/******************************************************************************/
//                                                                            //
//                           InstantCMS v1.10.6                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2015                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

function rssyandex($component=null, $item_id=null){

    $inCore = cmsCore::getInstance();
    $inConf = cmsConfig::getInstance();

    $model = new cms_model_rssyandex();

    global $_LANG;

    $component = isset($component) ? $component : cmsCore::request('target', 'str', 'rssyandex');
    $item_id   = isset($item_id) ? $item_id : cmsCore::request('item_id', 'str', 'all');

    if(!$inCore->isComponentInstalled($component)) { cmsCore::error404(); }

	if (!preg_match('/^([a-z0-9_\-]+)$/ui', $item_id)) { $item_id = 0; }

	if ($item_id == 'all') { $item_id = 0; }

////////////////////////////////////////////////////////////////////////////////
if ($inCore->do == 'view'){

	if (!file_exists(PATH.'/components/'.$component.'/prssyandex.php')){

        header('HTTP/1.0 404 Not Found');
        header('HTTP/1.1 404 Not Found');
        header('Status: 404 Not Found');

        cmsCore::halt($_LANG['NOT_RSS_GENERATOR']);

    }

	cmsCore::loadLanguage('components/'.$component);
	cmsCore::includeFile('components/'.$component.'/prssyandex.php');

	$rssyandexdata = call_user_func_array('rssyandex_'.$component, array($item_id, $model->config));
	if(!$rssyandexdata['channel']){
        header('HTTP/1.1 203 Non-Authoritative Information');
        cmsCore::halt($_LANG['NOT_POST_IN_RSS']);
    }

	$channel = $rssyandexdata['channel'];
	$items   = $rssyandexdata['items'];

	if ($model->config['addsite']) { $channel['title'] .= ' :: ' . $inConf->sitename; }
	$channel['title'] = trim(htmlspecialchars(strip_tags($channel['title'])));

	header('Content-Type: application/rss+xml; charset=utf-8');

	$rssyandex .= '<?xml version="1.0" encoding="utf-8" ?>' ."\n";
	$rssyandex .= '<rss  xmlns:yandex="http://news.yandex.ru"
      xmlns:media="http://search.yahoo.com/mrss/"
      xmlns:turbo="http://turbo.yandex.ru"
	  version="2.0"
	  >' ."\n";
		$rssyandex .= '<channel>' ."\n";
			// Канал
			$rssyandex .= '<title>'.$channel['title'].'</title>' ."\n";
			$rssyandex .= '<link>'.$channel['link'].'</link>' ."\n";
			$rssyandex .= '<description>'.trim(htmlspecialchars(strip_tags($channel['description']))).'</description>' ."\n";

			if ($model->config['icon_on']){
				$rssyandex .= '<image>'."\n";
					$rssyandex .= '<title>'.$channel['title'].'</title>'."\n";
					$rssyandex .= '<url>'.HOST.$model->config['icon_url'].'</url>'."\n";
					$rssyandex .= '<link>'.$channel['link'].'</link>'."\n";
				$rssyandex .= '</image>'."\n";
			}

			// Содержимое канала
			if (is_array($items) && $items){
				foreach ($items as $item){
			if($item['truefalse']){$truefalse = 'true';}else{$truefalse = 'false';}
				$rssyandex .= '<item turbo="'.$truefalse.'">' ."\n";
						$rssyandex .= '<link>'.$item['link'].'</link>' ."\n";
						$rssyandex .= '<author>'.$item['author'].'</author>' ."\n";
						$rssyandex .= '<category>'.$item['category'].'</category>' ."\n";
						$rssyandex .= '<title>'.$item['title'].'</title>' ."\n";
						$rssyandex .= '<pubDate>'.date('r', strtotime($item['pubdate'])+($inConf->timediff*3600)).'</pubDate>' ."\n";
						$rssyandex .= '<turbo:content>
							<header>'."\n";
                        $rssyandex .= '<figure>'."\n";
                        $rssyandex .= '<img src="'.$item['image'].'"  />' ."\n";
                        $rssyandex .= '</figure>' ."\n";
						$rssyandex .= '<h1>'.trim(htmlspecialchars(strip_tags($item['title']))).'</h1>' ."\n";
						$rssyandex .= '</header>' ."\n";
						$rssyandex .= '<![CDATA['.$item['contacts'].$item['content'].']]>
						</turbo:content>' ."\n";
						$rssyandex .= '<yandex:related>'."\n";
						$rssyandex .= '<link ' .'url="'.HOST.$item['yandexrelatedlink'].'" '.'img="'.HOST.$item['yandexrelatedimg'].'">'.$item['yandexrelatedtext'].'</link>'."\n";
						$rssyandex .= '<link ' .'url="'.HOST.$item['yandexrelatedlink2'].'" '.'img="'.HOST.$item['yandexrelatedimg2'].'">'.$item['yandexrelatedtext2'].'</link>'."\n";
						$rssyandex .= '</yandex:related>'."\n";
					$rssyandex .= '</item>' ."\n";
				}
			}
		$rssyandex .= '</channel>' ."\n";
	$rssyandex .= '</rss>';

	cmsCore::halt($rssyandex);

}
////////////////////////////////////////////////////////////////////////////////

}